#delim ; 
program define _DisplayMethodInfo;
	syntax, method(string) [bwidth(string) kernel(string) ngrid(string) DPolinomials(string)];
	
	if ("`method'" == "NP") {;
	
	    display as result "   Local Instrumetal Variables: Non-parametric estimator";

      if (missing("`kernel'") |
         !inlist("`kernel'","epanechnikov","biweight","cosine","gaussian","parzen","rectangle","triangle"))
         display in yellow "   Kernel method is not specified, use default: gaussian";
      else display in yellow "   Kernel method:" _col(30)  as text "`kernel'";
      
      if (missing("`bwidth'"))
          display   in yellow "   BandWidth is not specified, use default: 0.1";
      else display in yellow "   BandWidth: " _col(30) as text "`bwidth'";
      
	}; // end if NP

	if ("`method'" == "PARAMETRIC") {;	
		  display in yellow " Local Instrumetal Variable: Parametric estimator";
	}; // end if PARAMETRIC

	if ("`method'" == "POLY") {;
      display in yellow " Local Instrumetal Variable: Polynomial estimator";
      display in yellow "   Degree of polynomial  :" _col(30) as text "`dpolinomials'";
	}; // end if POLY

  if (missing("`ngrid'")) display in yellow  "   Number of grid points is not specified, use default: `=_N' ";
  else display in yellow  "   Number of grid points : " _col(30) as text "`ngrid' ";
  	
  display in yellow  "   Number of observations: "  _col(30) as text "`=_N'   " _newline;
	
end; // end program DisplayMethodInfo
